require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_CALLOUT_H_)) {
    eval 'sub _SYS_CALLOUT_H_ () {1;}' unless defined(&_SYS_CALLOUT_H_);
    unless(defined(&_SYS_QUEUE_H_)) {
	require 'sys/queue.ph';
    }
    unless(defined(&_SYS_LOCK_H_)) {
	require 'sys/lock.ph';
    }
    unless(defined(&_SYS_SPINLOCK_H_)) {
	require 'sys/spinlock.ph';
    }
    undef(&CALLOUT_TYPESTABLE) if defined(&CALLOUT_TYPESTABLE);
    if(defined(&CALLOUT_TYPESTABLE)) {
    } else {
    }
    if(defined(&CALLOUT_TYPESTABLE)) {
	eval 'sub callout_set_arg {
	    my($cc, $_arg) = @_;
    	    eval q((($cc)-> &qarg = ($_arg)));
	}' unless defined(&callout_set_arg);
	eval 'sub callout_arg {
	    my($cc) = @_;
    	    eval q((($cc)-> &qarg));
	}' unless defined(&callout_arg);
	eval 'sub callout_func {
	    my($cc) = @_;
    	    eval q((($cc)-> &qfunc));
	}' unless defined(&callout_func);
    } else {
	eval 'sub callout_set_arg {
	    my($cc, $_arg) = @_;
    	    eval q((($cc)-> ($toc->{qarg}) = ($_arg)));
	}' unless defined(&callout_set_arg);
	eval 'sub callout_arg {
	    my($cc) = @_;
    	    eval q((($cc)-> ($toc->{qarg})));
	}' unless defined(&callout_arg);
	eval 'sub callout_func {
	    my($cc) = @_;
    	    eval q((($cc)-> ($toc->{qfunc})));
	}' unless defined(&callout_func);
    }
    if(defined(&_KERNEL)) {
	eval 'sub CALLOUT_DEBUG () {1;}' unless defined(&CALLOUT_DEBUG);
	if(defined(&CALLOUT_DEBUG)) {
	    eval 'sub CALLOUT_DEBUG_ARGS () {,  &const \'char\' * &ident, \'int\'  &lineno;}' unless defined(&CALLOUT_DEBUG_ARGS);
	    eval 'sub CALLOUT_DEBUG_PASSTHRU () {,  &ident,  &lineno;}' unless defined(&CALLOUT_DEBUG_PASSTHRU);
	} else {
	    eval 'sub CALLOUT_DEBUG_ARGS () {1;}' unless defined(&CALLOUT_DEBUG_ARGS);
	    eval 'sub CALLOUT_DEBUG_PASSTHRU () {1;}' unless defined(&CALLOUT_DEBUG_PASSTHRU);
	}
	if(defined(&CALLOUT_DEBUG)) {
	    eval 'sub callout_init {
	        my($co) = @_;
    		eval q( &_callout_init($co,  &__FILE__,  &__LINE__));
	    }' unless defined(&callout_init);
	    eval 'sub callout_init_mp {
	        my($co) = @_;
    		eval q( &_callout_init_mp($co,  &__FILE__,  &__LINE__));
	    }' unless defined(&callout_init_mp);
	    eval 'sub callout_init_lk {
	        my($co, $lk) = @_;
    		eval q( &_callout_init_lk($co, $lk,  &__FILE__,  &__LINE__));
	    }' unless defined(&callout_init_lk);
	} else {
	    eval 'sub callout_init {
	        my($co) = @_;
    		eval q( &_callout_init($co));
	    }' unless defined(&callout_init);
	    eval 'sub callout_init_mp {
	        my($co) = @_;
    		eval q( &_callout_init_mp($co));
	    }' unless defined(&callout_init_mp);
	    eval 'sub callout_init_lk {
	        my($co, $lk) = @_;
    		eval q( &_callout_init_lk($co, $lk));
	    }' unless defined(&callout_init_lk);
	}
    }
}
1;
