require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_SPINLOCK2_H_)) {
    eval 'sub _SYS_SPINLOCK2_H_ () {1;}' unless defined(&_SYS_SPINLOCK2_H_);
    unless(defined(&_KERNEL)) {
	die("This file should not be included by userland programs.");
    }
    unless(defined(&_SYS_SYSTM_H_)) {
	require 'sys/systm.ph';
    }
    unless(defined(&_SYS_THREAD2_H_)) {
	require 'sys/thread2.ph';
    }
    unless(defined(&_SYS_GLOBALDATA_H_)) {
	require 'sys/globaldata.ph';
    }
    require 'machine/atomic.ph';
    require 'machine/cpufunc.ph';
    eval 'sub spin_lock {
        my($spin) = @_;
	    eval q( &_spin_lock($spin,  &__func__));
    }' unless defined(&spin_lock);
    eval 'sub spin_lock_quick {
        my($spin) = @_;
	    eval q( &_spin_lock_quick($spin,  &__func__));
    }' unless defined(&spin_lock_quick);
    eval 'sub spin_lock_shared {
        my($spin) = @_;
	    eval q( &_spin_lock_shared($spin,  &__func__));
    }' unless defined(&spin_lock_shared);
    eval 'sub spin_lock_shared_quick {
        my($spin) = @_;
	    eval q( &_spin_lock_shared_quick($spin,  &__func__));
    }' unless defined(&spin_lock_shared_quick);
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    eval 'sub _spin_lock {
        my($spin,$ident) = @_;
	    eval q({  &_spin_lock_quick( &mycpu, $spin, $ident); });
    }' unless defined(&_spin_lock);
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    eval 'sub spin_unlock {
        my($spin) = @_;
	    eval q({  &spin_unlock_quick( &mycpu, $spin); });
    }' unless defined(&spin_unlock);
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    if(defined(&DEBUG_LOCKS)) {
    }
    eval 'sub _spin_lock_shared {
        my($spin,$ident) = @_;
	    eval q({  &_spin_lock_shared_quick( &mycpu, $spin, $ident); });
    }' unless defined(&_spin_lock_shared);
    eval 'sub spin_unlock_shared {
        my($spin) = @_;
	    eval q({  &spin_unlock_shared_quick( &mycpu, $spin); });
    }' unless defined(&spin_unlock_shared);
# some #ifdef were dropped here -- fill in the blanks
    eval 'sub spin_init {
        my($spin,$__unused) = @_;
	    eval q({  ($spin->{counta}) = 0;  ($spin->{countb}) = 0; });
    }' unless defined(&spin_init);
    eval 'sub spin_uninit {
        my($spin) = @_;
	    eval q({ }  &endif );
    }' unless defined(&spin_uninit);
1;
